#include <stdio.h>
#include <stdlib.h>

#include "udm_config.h"
#include "udm_common.h"
#include "udm_db.h"
#include "udm_charset.h"
#include "udm_xmalloc.h"
#include "udm_utils.h"
#include "udm_agent.h"
#include "udm_word.h"


__INDLIB__ UDM_AGENT * UdmAllocAgent(UDM_ENV * Env, int handle, int db_open_mode){
	UDM_AGENT * result;
	int i;

	result=(UDM_AGENT*)malloc(sizeof(UDM_AGENT));
	memset(result, 0, sizeof(UDM_AGENT));
	result->Conf=Env;
	result->mwords=0;
	result->nwords=0;
	result->swords=0;
	result->handle=handle; /* Handle is used in multi-threaded version */
	result->action=0;
	result->state[0]=0;
	result->Word=NULL;
	result->buf=NULL;
	result->total_found=0;
	result->charset=UDM_CHARSET_USASCII;
	result->db=UdmAllocDB(result, db_open_mode);
        /* Reserve connection structure */
        result->connp = (UDM_CONN*)UdmXmalloc(sizeof(UDM_CONN));
        result->connp->indexer = result;
        result->connp->connp = (UDM_CONN*)UdmXmalloc(sizeof(UDM_CONN));
        result->connp->connp->indexer = result;
	result->wordinfo[0]=0;
	result->search_mode=0;
	result->sort_order=UDM_ORD_RATE;
	result->page_number=0;
	result->page_size=20;
	result->group_mask=0xffffffff;
	result->track_mode=0;
	UDMMEMZERO(&result->t_Spell,sizeof(UDM_SPELL));
	result->read_timeout=300;
	result->maxsize=1024*1024;
	result->cache_mode=UDM_CACHE_DISABLED;
	result->work_time=0;
	for(i=0;i<257;i++){
		result->crcdict[i]=-1;
	}

	return(result);
}
__INDLIB__ void UdmFreeAgent(UDM_AGENT *Indexer){

	if(Indexer){
		UdmFreeWords(Indexer);
		UdmFreeDB(Indexer);

		UDM_FREE(Indexer->Word);
		UDM_FREE(Indexer->buf);
		UDM_FREE(Indexer->connp->connp);
		UDM_FREE(Indexer->connp);
		UDM_FREE(Indexer);
	}
}


__INDLIB__ char * UdmAgentErrorMsg(UDM_AGENT *Indexer){
	return(UdmDBErrorMsg(Indexer->db));
}

__INDLIB__ void UdmAgentSetAction(UDM_AGENT *Indexer,int action){
	Indexer->action=action;
}
