#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <regex.h>

#include "udm_config.h"
#include "udm_utils.h"
#include "udm_common.h"
#include "udm_mimetype.h"


/********* AddType stuff *********************/

typedef struct mime_struct {
	regex_t	reg;
	char	*mime_type;
} UDM_MIME;

int UdmAddType(UDM_ENV * Conf,char * mime_type,char *reg, char *errstr){
#define ERRSTRSIZE 100
char regerrstr[ERRSTRSIZE];
int err;
UDM_MIME * Mime;
	if(Conf->nmimes>=Conf->mmimes){
		if(Conf->mmimes){
			Conf->mmimes+=16;
			Conf->Mime=realloc(Conf->Mime,Conf->mmimes*sizeof(UDM_MIME));
		}else{
			Conf->mmimes=16;
			Conf->Mime=malloc(Conf->mmimes*sizeof(UDM_MIME));
		}
	}
	Mime=Conf->Mime;
	Mime[Conf->nmimes].mime_type=strdup(mime_type);
	err=regcomp(&(Mime[Conf->nmimes].reg),reg,REG_EXTENDED|REG_ICASE);
	if(err){
		regerror(err,&(Mime[Conf->nmimes].reg),regerrstr,ERRSTRSIZE);
		sprintf(errstr,"Wrong regex in config file: %s: %s", reg,regerrstr);
		free(Mime[Conf->nmimes].mime_type);
		return(1);
	}
	Conf->nmimes++;
	return(0);
}
void UdmFreeTypes(UDM_ENV * Conf){
int i;
UDM_MIME * Mime;
	Mime=(UDM_MIME*)Conf->Mime;
	for(i=0;i<Conf->nmimes;i++){
		free(Mime[i].mime_type);
		regfree(&(Mime[i].reg));
	}
	Conf->nmimes=Conf->mmimes=0;
	UDM_FREE(Conf->Mime);
}

char * ContentType(UDM_ENV * Conf,char *url){
int i;
#define NS 10
regmatch_t subs[NS];
int err;
UDM_MIME * Mime;
	Mime=Conf->Mime;
	for(i=0;i<Conf->nmimes;i++){
		err=regexec(&(Mime[i].reg),url,NS,subs,0);
		if(!err)return(Mime[i].mime_type);
	}
	return(NULL);
}
